#include <jni.h>
#include <stdio.h>
#include "JNIVariable.h"
 
JNIEXPORT void JNICALL Java_JNIVariable_modifyInstanceVariable(JNIEnv *env, jobject thisObj) {
   // Lay tham chieu toi lop cua doi tuong
   jclass thisClass = env->GetObjectClass(thisObj);
 
   // Lay Field ID cua bien thanh vien "number"
   jfieldID fidNumber = env->GetFieldID(thisClass, "number", "I");
   if (NULL == fidNumber) return;
 
   // Lay gia tri bien thanh vien "number"
   jint number = env->GetIntField(thisObj, fidNumber);
   printf("In C, the int is %d\n", number);
 
   // Thay doi gia tri cua bien thanh vien "number"
   number = 99;
   env->SetIntField(thisObj, fidNumber, number);
 
   // Lay Field ID cua bien thanh vien "message"
   jfieldID fidMessage = env->GetFieldID(thisClass, "message", "Ljava/lang/String;");
   if (NULL == fidMessage) return;
 
   // Lay gia tri bien thanh vien "message"
   jstring message = (jstring) env->GetObjectField(thisObj, fidMessage);
 
   // Chuyen tu jstring sang C-string
   const char *cStr = env->GetStringUTFChars(message, NULL);
   if (NULL == cStr) return;
 
   printf("In C, the string is %s\n", cStr);

   // Giai phong tai nguyen
   env->ReleaseStringUTFChars(message, cStr);
 
   // Tao doi tuong jstring tu C-string
   message = env->NewStringUTF("Hello from C");
   if (NULL == message) return;
 
   // Chinh sua gia tri bien thanh vien "message"
   env->SetObjectField(thisObj, fidMessage, message);
}

JNIEXPORT void JNICALL Java_JNIVariable_modifyStaticVariable(JNIEnv *env, jobject thisObj) {
   // Lay tham chieu toi lop cua doi tuong
   jclass thisClass = env->GetObjectClass(thisObj);

   // Lay Field ID cua bien tinh "staticNumber"
   jfieldID fidStaticNumber = env->GetStaticFieldID(thisClass, "staticNumber", "D");
   if (NULL == fidStaticNumber) return;

   // Lay gia tri cua bien tinh "staticNumber"
   jdouble staticNumber = env->GetStaticDoubleField(thisClass, fidStaticNumber);
   printf("In C, the double is %f\n", staticNumber);
   
   // Thay doi gia tri bien tinh "staticNumber"
   staticNumber = 77.88;
   env->SetStaticDoubleField(thisClass, fidStaticNumber, staticNumber);
}
